var contabilidad = opener.contabilidad;
var mesDesde = 0;
var mesHasta = 0;

function iniciar(){/*{{{*/
  //Preparamos los parmetros del Balance
  var parametro = new Object();
  var ahora = new Date();
  var datosFechaDesde = opener.document.getElementById("textboxFechaDesdePGC").value.split("/");
  if (datosFechaDesde.length == 3)
    parametro.fechaDesde = new Date(datosFechaDesde[2],(datosFechaDesde[1] - 1),datosFechaDesde[0]);
  else
    parametro.fechaDesde = new Date(ahora.getYear() + 1900, 0, 1);
  var datosFechaHasta = opener.document.getElementById("textboxFechaHastaPGC").value.split("/");
  if (datosFechaHasta.length == 3)
    parametro.fechaHasta = new Date(datosFechaHasta[2],(datosFechaHasta[1] - 1),datosFechaHasta[0]);
  else
    parametro.fechaHasta = new Date(ahora.getYear() + 1900, 11, 31);
  if (opener.document.getElementById("checkboxPorMesesPGC").checked){
    parametro.porMeses = true;
    //Fijamos las variables globales de mesDesde y mesHasta
    mesDesde = parametro.fechaDesde.getYear()*12 + parametro.fechaDesde.getMonth();
    mesHasta = parametro.fechaHasta.getYear()*12 + parametro.fechaHasta.getMonth();
  }
  else parametro.porMeses = false;
  if (opener.document.getElementById("checkboxSumasYSaldosPGC").checked) parametro.sumasYSaldos = true;
  else parametro.sumasYSaldos = false;
  if (opener.document.getElementById("checkboxConPrevisionesPGC").checked) parametro.conPrevisiones = true;
  else parametro.conPrevisiones = false;
  
  var balancePGC = new BalancePGC(contabilidad, parametro, new PGC());
  balancePGC.preparar();
  if (!balancePGC.calcular()) window.close();
  document.getElementById("boxInforme").appendChild(balancePGC.ver());
  
  //Algunos detalles del Informe
  var fechaEdicion = new Date();
  document.getElementById("labelFechaEdicion").value = fechaEdicion.getDate() + "/" + (fechaEdicion.getMonth() + 1) + "/" + fechaEdicion.getFullYear();
  var comentario = "";
  if (parametro.fechaDesde)
    comentario += "Desde " + opener.document.getElementById("textboxFechaDesdePGC").value;
  if (parametro.fechaHasta)
    comentario += " hasta " + opener.document.getElementById("textboxFechaHastaPGC").value + ". ";
  if (parametro.conPrevisiones)
    comentario += "Con previsiones.";
  document.getElementById("labelComentario").value = comentario;
  
}/*}}}*/

//INFORME DE TIPO BALANCE PGC{{{

// La Clase BalancePGC

function BalancePGC(contabilidad, parametro, PGC){ //{{{ 
  this.contabilidad = contabilidad;
  this.parametro = parametro;
  this.PGC = PGC;
  
  this.preparar = prepararBalancePGC;
  this.calcular = calcularBalancePGC;
  this.ver = verBalancePGC;

  return this;
} //}}}

function prepararBalancePGC(){/*{{{*/
//A las CuentasPGC les prototipamos un mtodo para ver su treeitem
  CuentaPGC.prototype.verTreeitem = verTreeitemCuentaPGC;
  CuentaPGC.prototype.saldar = saldarCuentaPGC;
  for (var i = 0; i < this.PGC.cuenta.length; i++)
    if (this.PGC.cuenta[i])  //Algunas cuentas no existen
      prepararCuentaPGC(this.PGC.cuenta[i], this.parametro);
}/*}}}*/

function prepararCuentaPGC(cuenta, parametro){/*{{{*/
  cuenta.mes = new Array();
  for (var j=mesDesde; j<=mesHasta; j++){
    cuenta.mes[j] = new Object();
    cuenta.mes[j].incremento = 0;
    cuenta.mes[j].decremento = 0;
    cuenta.mes[j].saldo = 0;
  }
}/*}}}*/

function saldarCuentaPGC(){
//Calcula el saldo de la cuenta (y de sus subcuentas)
  for (var i=0; i<this.cuenta.length; i++){
    this.cuenta[i].saldar();
    for (var j=mesDesde; j<=mesHasta; j++){
      this.mes[j].incremento = eval(this.mes[j].incremento) + eval(this.cuenta[i].mes[j].incremento);
      this.mes[j].decremento = eval(this.mes[j].decremento) + eval(this.cuenta[i].mes[j].decremento);
    }
  }
  
  //Calculamos los saldos
  for (var l=mesDesde; l<=mesHasta; l++){
    var saldoAnterior = 0;
    if (this.mes[l-1])  //Por si no hay saldo anterior
      saldoAnterior = this.mes[l-1].saldo;
    this.mes[l].saldo = saldoAnterior + this.mes[l].incremento + this.mes[l].decremento;
  }
  
  /*
  for (var j=mesDesde; j<mesHasta; j++)
    if (j == 0)
      this.mes[j].saldo = eval(this.mes[j].incremento) - eval(this.mes[j].decremento);
    else
      this.mes[j].saldo = eval(this.mes[j-1].saldo) + eval(this.mes[j].incremento) - eval(this.mes[j].decremento);
  */
}

function verTreeitemCuentaPGC(parametro){/*{{{*/
//Devuelve el treeitem de la cuenta
//Es un mtodo del objeto CuentaPGC
//El parmetro es igual al del balance
  var cuentaTreeitem = document.createElement("treeitem");
  var cuentaTreerow = document.createElement("treerow");
  //La celda con el nombre de la cuenta
  var cuentaTreecell = document.createElement("treecell");
  cuentaTreecell.setAttribute("label", this.pgc + " - " + this.nombre);
  cuentaTreerow.appendChild(cuentaTreecell);

  //Las celdas con los datos de la propia cuenta, para todos los meses del periodo
  for (var j=mesDesde; j<=mesHasta; j++){
    if (parametro.sumasYSaldos){
      //La celda de Incremento
      var listaCuentaTreecellIncremento = new Array();
      listaCuentaTreecellIncremento[j] = document.createElement("treecell");
      var incremento = darFormato(Math.round(this.mes[j].incremento * 100)/100);
      listaCuentaTreecellIncremento[j].setAttribute("label", incremento);
      listaCuentaTreecellIncremento[j].setAttribute("style", "text-align: right;");
      cuentaTreerow.appendChild(listaCuentaTreecellIncremento[j]);
    
      //La celda de Decremento
      var listaCuentaTreecellDecremento = new Array();
      listaCuentaTreecellDecremento[j] = document.createElement("treecell");
      var decremento = darFormato(Math.round(this.mes[j].decremento * 100)/100);
      listaCuentaTreecellDecremento[j].setAttribute("label", decremento);
      listaCuentaTreecellDecremento[j].setAttribute("style", "text-align: right;");
      cuentaTreerow.appendChild(listaCuentaTreecellDecremento[j]);
    }
    //La celda de saldo
    var listaCuentaTreecellSaldo = new Array();
    listaCuentaTreecellSaldo[j] = document.createElement("treecell");
    var saldo = darFormato(Math.round(this.mes[j].saldo * 100)/100);
    listaCuentaTreecellSaldo[j].setAttribute("label", saldo);
    listaCuentaTreecellSaldo[j].setAttribute("style", "text-align: right;");
    cuentaTreerow.appendChild(listaCuentaTreecellSaldo[j]);
  }
  cuentaTreeitem.appendChild(cuentaTreerow);
    
  //Llamamos a verTreeitem de sus hijos
  if (this.cuenta.length > 0){
    cuentaTreeitem.setAttribute("container", "true");
    cuentaTreeitem.setAttribute("open", "false");
    var subcuentaTreechildren = document.createElement("treechildren");
    for (var i=0; i<this.cuenta.length; i++)
      subcuentaTreechildren.appendChild(this.cuenta[i].verTreeitem(parametro));
    cuentaTreeitem.appendChild(subcuentaTreechildren);
  }

  return cuentaTreeitem;
}/*}}}*/

function calcularBalancePGC(){/*{{{*/
  //Revisamos todos los asientos y los anotamos en el rbol de cuentas PGC
  
  for (var i=0; i<this.contabilidad.asiento.length; i++){
    //Si hay definido un periodo de fechas, solo procesamos asientos en ese periodo
    var procesar = true;
    if (this.parametro.fechaHasta != null)
      if (this.contabilidad.asiento[i].fecha > this.parametro.fechaHasta) procesar = false;
    if (!this.parametro.conPrevisiones && this.contabilidad.asiento[i].prevision) procesar = false;
    if (procesar){ //Si hay que procesar el asiento...
      var asiento = this.contabilidad.asiento[i];
      //Comprobamos si cuadra sin las cuentas no PGC
      var saldo = 0;
      for (var j=0; j<asiento.apunte.length; j++)
	if (this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc){
	  if (!this.PGC.cuenta[this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc]){ //Si no existe la cuenta en el PGC, la creamos
	    //Si la siguiente sentencia no nos est indicando que esto requiere un refactoring... 
	    this.PGC.cuenta[this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc] = this.PGC.nuevaCuenta(this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc, this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).nombre, this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).tipo);
	    prepararCuentaPGC(this.PGC.cuenta[this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc]);
	  }
	  var tipo = this.PGC.cuenta[this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc].tipo;
	  var importe = Math.round(parseFloat(asiento.apunte[j].importe) * 100) / 100;
	  if ((tipo == "Activo") || (tipo == "Gastos")) saldo += importe;
	  else saldo -= importe;
	}
      if ((Math.round(saldo * 100)/100) != 0){
	alert("El asiento " + asiento.nombre + " NO CUADRA respecto al PGC por " + saldo + ".\nTienes que corregirlo para poder generar el Balance por PGC."); 
	return false;
      }
    
      //Anotamos sus apuntes PGC en el rbol de cuentas PGC
      for (var j=0; j<asiento.apunte.length; j++)
	if (this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc){
	  this.PGC.cuenta[this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc].nombre = this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).nombre;
	  var mes = 0;
	  if (this.parametro.porMeses){
	    mes = asiento.fecha.getYear() * 12 + asiento.fecha.getMonth();
	    if (this.parametro.fechaDesde != null)
	      if (asiento.fecha < this.parametro.fechaDesde) mes = mesDesde;
	  }
	  this.PGC.cuenta[this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc].mes[mes].incremento = eval(this.PGC.cuenta[this.contabilidad.verCuentaPorId(asiento.apunte[j].idCuenta).pgc].mes[mes].incremento) + eval(asiento.apunte[j].importe);
	}
    } //if (procesar)
  }

  //Saldamos el rbol de cuentas PGC
  for (var i=1; i<10; i++) //Recorremos las cuentas de primer nivel, saldndolas
    if (this.PGC.cuenta[i]) //Acordmonos que el gracioso que hizo el PGC, se salt el grupo 8
      this.PGC.cuenta[i].saldar();
  
  return true;
}/*}}}*/

function verBalancePGC (){	//{{{
  //Creamos la estructura del rbol
  var arbol = document.createElement("tree");
  arbol.setAttribute("id", "treeInforme");
  arbol.setAttribute("style","overflow: auto;");
  arbol.setAttribute("flex","1");
  arbolCols = document.createElement("treecols");
  //Columna de Cuenta
  var arbolColCuenta = document.createElement("treecol");
  arbolColCuenta.setAttribute("id","colCuenta");
  arbolColCuenta.setAttribute("primary","true");
  arbolColCuenta.setAttribute("label","Cuenta");
  arbolColCuenta.setAttribute("flex","1");
  arbolCols.appendChild(arbolColCuenta);
  arbol.appendChild(arbolCols);
  
  for (var i=mesDesde; i<=mesHasta; i++){
    //Creamos las columnas para todo el ao
    var mes = new Array("Ene","Feb","Mar","Abr","May","Jun","Jul","Ago","Sep","Oct","Nov","Dic");
    if (this.parametro.sumasYSaldos){
	//Columna de Incremento
	var arbolSplitter = document.createElement("splitter");
	arbolSplitter.setAttribute("class","tree-splitter");
	arbolCols.appendChild(arbolSplitter);
	arbolCol = document.createElement("treecol");
	var idCol = "colIncremento" + i;
	arbolCol.setAttribute("id",idCol);
	arbolCol.setAttribute("label","Inc");
	arbolCol.setAttribute("style","text-align: right;");
	arbolCols.appendChild(arbolCol);
	//Columna de Decremento
	arbolSplitter = document.createElement("splitter");
	arbolSplitter.setAttribute("class","tree-splitter");
	arbolCols.appendChild(arbolSplitter);
	arbolCol = document.createElement("treecol");
	var idCol = "colDecremento" + i;
	arbolCol.setAttribute("id",idCol);
	arbolCol.setAttribute("label","Dec");
	arbolCol.setAttribute("style","text-align: right;");
	arbolCols.appendChild(arbolCol);
      }
      //Columna de Saldo
      arbolSplitter = document.createElement("splitter");
      arbolSplitter.setAttribute("class","tree-splitter");
      arbolCols.appendChild(arbolSplitter);
      arbolCol = document.createElement("treecol");
      var idCol = "colSaldo" + i;
      arbolCol.setAttribute("id",idCol);
      if (this.parametro.porMeses)
	arbolCol.setAttribute("label", mes[i%12]);
      else arbolCol.setAttribute("label","Saldo");
      arbolCol.setAttribute("style","font-weight:bold; text-align: right;");
      arbolCols.appendChild(arbolCol);
    }
  //Creamos el treechildren
  var arbolTreechildren = document.createElement("treechildren");
  for (var i=1; i<10; i++)
    if (this.PGC.cuenta[i]) arbolTreechildren.appendChild(this.PGC.cuenta[i].verTreeitem(this.parametro));
  
  arbol.appendChild(arbolTreechildren);
  return arbol;
  
} //}}}

function darFormato(importe){/*{{{*/
//Devuelve un nmero con dos decimales y el smbolo del euro
  //Lo redondeamos a dos decimales
  importe = Math.round(importe*100)/100;

  modificador = 0;
  if (importe < 0) modificador = 1;
  
  importe = "" + importe; //Para que lo trate como una cadena de texto
  
  //Reemplazamos el punto decimal por una coma
  importe = importe.replace(".",",");
  
  //Le ponemos los decimales, si no los tiene
  var temporal = importe.split(",");
  if (temporal.length == 1) importe += ",00";
  else
    if (temporal[1].length == 1) importe += "0";
    
  //Le ponemos los separados de miles
  //var max = (Math.round(importe.length/4) - 1);
  var max = (importe.length-(6+modificador))/3;
  for (var i=0; i<max; i++)
    importe = importe.substr(0,importe.length - (6+4*i)) + "." + importe.substr(importe.length - (6+4*i), importe.length);
  
  //Le aadimos el smbolo del euro
  importe += contabilidad.moneda;
  
  return importe;
}/*}}}*/

//Funciones del Men de Balance

function menuitemImprimir(){
//Imprime el Informe de Balance
  window.print();
}

function menuitemCSV(){
//Guarda el informe en formato CSV (Comma Separated Value)
}

function menuitemHTML(){
//Guarda el informe en formato HTML
}

