//econtab-testsuite.js
//Conjunto de casos de test para eContab

var econtabTestSuite = new TestSuite("Pruebas de eContab");
econtabTestSuite.add(new TestCase("Crear la Contabilidad", testCrearContabilidad));
econtabTestSuite.add(new TestCase("Buscar Asientos", testBuscarAsientos));
var testRunner = new TestRunner(econtabTestSuite);

function testCrearContabilidad(){/*{{{*/
  assertNotNull("Nueva Contabilidad", new Contabilidad(null));
  docXML = document.implementation.createDocument("","",null);
  docXML.async = false;
  docXML.load("prueba.xml");
  var contabilidad = new Contabilidad(docXML);
  assertNotNull("Abrir Contabilidad", contabilidad);
  //Comprobar que el proveedor Fernando tiene cuenta bancaria asociada
  assertNotNull("Proveedor 1 con Cuenta Bancaria", contabilidad.proveedor[1].cuentaBancaria);
  assertEquals("Hay 1 predefinido", 1, contabilidad.predefinido.length); 
}/*}}}*/

function testBuscarAsientos(){/*{{{*/
  docXML = document.implementation.createDocument("","",null);
  docXML.async = false;
  docXML.load("prueba.xml");
  var contabilidad = new Contabilidad(docXML);
  var criterio = new Object();
  criterio.asiento = true;
  criterio.prevision = false;
  criterio.fechaDesde = new Date(2004, 4, 5);
  criterio.fechaHasta = new Date(2004, 4, 5);
  criterio.tipo = new Object();
  criterio.tipo.id = 6;
  criterio.idCuenta = 3;
  criterio.importe = 600;
  resultado = contabilidad.buscarAsientos(criterio);
  assertEquals("Bsqueda de Asiento", "Encaje", resultado[0].nombre);
}/*}}}*/
