//testrunner.js
//Functions for XULUnit User Interface (TestRunner)

/* Todo:
  - Add colors to results
*/

//Class TestRunner
function TestRunner(testSuite){/*{{{*/
  //Creates a XulUnit User Interface object (called TestRunner) for the testSuite
  //TestRunner is used to present results on a graphical predefined (testrunner.xul) interface

  this.testSuite = testSuite;

  this.run = runTestRunner;
  this.showResults = showResultsTestRunner;
  this.showDetails = showDetailsTestRunner;
  //this.showTestCase = showTestCaseTestRunner;
  //this.showTest = showTestTestRunner;

  function runTestRunner(){/*{{{*/
  //Runs TestSuite and show results
    this.testSuite.run();
    this.showResults();
  }/*}}}*/

  function showResultsTestRunner(){/*{{{*/
  //Shows data for the TestSuite
  
    //Total Data
    document.getElementById("labelTotalTestCases").value = "Total Test Cases: " + this.testSuite.testCase.length;
    var totalTests = 0;
    for (var i=0; i<this.testSuite.testCase.length; i++)
      totalTests += this.testSuite.testCase[i].test.length;
    document.getElementById("labelTotalTests").value = "Total Tests: " + totalTests;
    

    //TreeResult Construction
    resultTreechildren = document.createElement("treechildren");
    document.getElementById("treeResults").appendChild(resultTreechildren);
    
    testSuiteTreeitem = document.createElement("treeitem");
    testSuiteTreeitem.testObject = this.testSuite;
    resultTreechildren.appendChild(testSuiteTreeitem);

    testSuiteTreerow = document.createElement("treerow");
    testSuiteTreeitem.appendChild(testSuiteTreerow);
    
    testSuiteNameTreecell = document.createElement("treecell");
    testSuiteNameTreecell.setAttribute("label", this.testSuite.name);
    testSuiteTreerow.appendChild(testSuiteNameTreecell);
    
    testSuiteResultTreecell = document.createElement("treecell");
    testSuiteResultTreecell.setAttribute("label", getResultText(this.testSuite.getResult()));
    testSuiteResultTreecell.setAttribute("properties", "testPasses");//ESTO ES UNA PRUEBA
    testSuiteTreerow.appendChild(testSuiteResultTreecell);
   
    //Show each TestCase
    if (this.testSuite.testCase.length > 0){
      testSuiteTreeitem.setAttribute("container","true");
      testSuiteTreeitem.setAttribute("open", true);
      testSuiteTreechildren = document.createElement("treechildren");
      testSuiteTreeitem.appendChild(testSuiteTreechildren);

      for(var i=0; i<this.testSuite.testCase.length; i++){
	testCaseTreeitem = document.createElement("treeitem");
	testCaseTreeitem.testObject = this.testSuite.testCase[i];
	testSuiteTreechildren.appendChild(testCaseTreeitem);

	testCaseTreerow = document.createElement("treerow");
	testCaseTreeitem.appendChild(testCaseTreerow);

	testCaseNameTreecell = document.createElement("treecell");
	testCaseNameTreecell.setAttribute("label", this.testSuite.testCase[i].name);
	testCaseTreerow.appendChild(testCaseNameTreecell);
    
	testCaseResultTreecell = document.createElement("treecell");
	testCaseResultTreecell.setAttribute("label", getResultText(this.testSuite.testCase[i].getResult()));
	testCaseTreerow.appendChild(testCaseResultTreecell);
    
	//Show each Test for current TestCase
	if (this.testSuite.testCase[i].test.length > 0){
	  testCaseTreeitem.setAttribute("container","true");
	  testCaseTreeitem.setAttribute("open", false);
	  testTreechildren = document.createElement("treechildren");
	  testCaseTreeitem.appendChild(testTreechildren);

	  for(var j=0; j<this.testSuite.testCase[i].test.length; j++){
	    testTreeitem = document.createElement("treeitem");
	    testTreeitem.testObject = this.testSuite.testCase[i].test[j];
	    testTreechildren.appendChild(testTreeitem);

	    testTreerow = document.createElement("treerow");
	    testTreeitem.appendChild(testTreerow);

	    testCommentTreecell = document.createElement("treecell");
	    testCommentTreecell.setAttribute("label", this.testSuite.testCase[i].test[j].comment);
	    testTreerow.appendChild(testCommentTreecell);
    
	    testResultTreecell = document.createElement("treecell");
	    testResultTreecell.setAttribute("label", getResultText(this.testSuite.testCase[i].test[j].result));
	    testTreerow.appendChild(testResultTreecell);
	  }
	}
      }
    }
  }/*}}}*/

  function showDetailsTestRunner(){/*{{{*/
  //Shows details for a testObject (this means testSuite, testCase or test)
    treeResults = document.getElementById("treeResults");
    testObject = treeResults.view.getItemAtIndex(treeResults.currentIndex).testObject;
    
    switch (testObject.type){
      case XULUNIT_TESTSUITE:
      case XULUNIT_TESTCASE:
	document.getElementById("labelDetailNameComment").value = "Name: " + testObject.name;
	document.getElementById("labelDetailResult").value = "Result: " + getResultText(testObject.getResult());
	document.getElementById("labelDetailBreakMessage").value = "";
	break;
      default:
	document.getElementById("labelDetailNameComment").value = "Comment: " + testObject.comment;
	document.getElementById("labelDetailResult").value = "Result: " + getResultText(testObject.result);
	if (testObject.result == XULUNIT_BREAK)
	  document.getElementById("labelDetailBreakMessage").value = testObject.breakMessage;
    } 
    document.getElementById("labelDetailType").value = "Type: " + getTestTypeText(testObject.type);
  }/*}}}*/
}//TestRunner Class/*}}}*/

//Functions for constant translation 
function getResultText(result){/*{{{*/
//Returns test result on a human readble string
  switch (result){
    case XULUNIT_PASS:
      return("PASS");
    case XULUNIT_FAIL:
      return("FAIL");
    case XULUNIT_BREAK:
      return("BREAK");
    case XULUNIT_UNKNOWN:
      return("UNKNOWN");
  }
}/*}}}*/

function getTestTypeText(type){/*{{{*/
//Returns test type on a human readble string
  switch (type){
    case XULUNIT_ASSERT:
      return("Assert");
    case XULUNIT_ASSERTTRUE:
      return("Assert True");
    case XULUNIT_ASSERTFALSE:
      return("Assert False");
    case XULUNIT_ASSERTEQUALS:
      return("Assert Equals");
    case XULUNIT_ASSERTNOTEQUALS:
      return("Assert Not Equals");
    case XULUNIT_ASSERTNULL:
      return("Assert Null");
    case XULUNIT_ASSERTNOTNULL:
      return("Assert Not Null");
    case XULUNIT_ASSERTUNDEFINED:
      return("Assert Undefined");
    case XULUNIT_ASSERTNOTUNDEFINED:
      return("Assert Not Undefined");
    case XULUNIT_ASSERTNAN:
      return("Assert NaN");
    case XULUNIT_ASSERTNOTNAN:
      return("Assert Not NaN");
    case XULUNIT_TESTSUITE:
      return("Test Suite");
    case XULUNIT_TESTCASE:
      return("Test Case");
  }
}/*}}}*/
